# Class `luci.http`

## Functions

build_querystring (table) | Create a querystring out of a table of key - value pairs.
close () | Close the HTTP-Connection.
content () | Return the request content if the request was of unknown type.
formvalue (name, noparse) | Get a certain HTTP input value or a table of all input values.
formvaluetable (prefix) | Get a table of all HTTP input values with a certain prefix.
getcookie (name) | Get the value of a certain HTTP-Cookie.
getenv (name) | Get the value of a certain HTTP environment variable or the environment table itself.
header (key, value) | Send a HTTP-Header.
mimedecode_message_body (src, msg, filecb) | Decode a mime encoded http message body with multipart/form-data Content-Type.
parse_message_body (src, msg, filecb) | Try to extract and decode a http message body from the given ltn12 source.
prepare_content (mime) | Set the mime type of following content data.
redirect (url) | Redirects the client to a new URL and closes the connection.
setfilehandler (callback) | Set a handler function for incoming user file uploads.
source () | Get the RAW HTTP input source
splice (fp, size) | Splice data from a filedescriptor to the client.
status (code, message) | Set the HTTP status code and status message.
urldecode (str, no_plus) | Return the URL-decoded equivalent of a string.
urldecode_message_body (src, msg) | Decode an urlencoded http message body with application/x-www-urlencoded Content-Type.
urldecode_params (url, tbl) | Extract and split urlencoded data pairs, separated bei either "&" or ";" from given url or string.
urlencode (str) | Return the URL-encoded equivalent of a string.
urlencode_params (tbl) | Encode each key-value-pair in given table to x-www-urlencoded format, separated by "&".
write (content, src_err) | Send a chunk of content data to the client.
write_json (data) | Send the given data as JSON encoded string.

## Functions

build_querystring (table)
  Create a querystring out of a table of key - value pairs.

  ### Parameters

  - table: Query string source table

  ### Return value:

  Encoded HTTP query string
close ()
  Close the HTTP-Connection.
content ()
  Return the request content if the request was of unknown type.

  ### Return values:

  1. HTTP request body
  2. HTTP request body length
formvalue (name, noparse)
  Get a certain HTTP input value or a table of all input values.

  ### Parameters

  - name: Name of the GET or POST variable to fetch
  - noparse: Don't parse POST data before getting the value

  ### Return value:

  HTTP input value or table of all input value
formvaluetable (prefix)
  Get a table of all HTTP input values with a certain prefix.

  ### Parameters

  - prefix: Prefix

  ### Return value:

  Table of all HTTP input values with given prefix
getcookie (name)
  Get the value of a certain HTTP-Cookie.

  ### Parameters

  - name: Cookie Name

  ### Return value:

  String containing cookie data
getenv (name)
  Get the value of a certain HTTP environment variable or the environment table itself.

  ### Parameters

  - name: Environment variable

  ### Return value:

  HTTP environment value or environment table
header (key, value)
  Send a HTTP-Header.

  ### Parameters

  - key: Header key
  - value: Header value
mimedecode_message_body (src, msg, filecb)
  Decode a mime encoded http message body with multipart/form-data Content-Type. Stores all extracted data associated with its parameter name in the params table within the given message object. Multiple parameter values are stored as tables, ordinary ones as strings. If an optional file callback function is given then it is feeded with the file contents chunk by chunk and only the extracted file name is stored within the params table. The callback function will be called subsequently with three arguments: o Table containing decoded (name, file) and raw (headers) mime header data o String value containing a chunk of the file data o Boolean which indicates wheather the current chunk is the last one (eof)

  ### Parameters

  - src: Ltn12 source function
  - msg: HTTP message object
  - filecb: File callback function (optional)

  ### Return values:

  1. Value indicating successful operation (not nil means "ok")
  2. String containing the error if unsuccessful

  ### See also:

  - parse_message_header
parse_message_body (src, msg, filecb)
  Try to extract and decode a http message body from the given ltn12 source. This function will examine the Content-Type within the given message object to select the appropriate content decoder. Currently the application/x-www-urlencoded and application/form-data mime types are supported. If the encountered content encoding can't be handled then the whole message body will be stored unaltered as "content" property within the given message object.

  ### Parameters

  - src: Ltn12 source function
  - msg: HTTP message object
  - filecb: File data callback (optional, see mimedecode_message_body())

  ### Return values:

  1. Value indicating successful operation (not nil means "ok")
  2. String containing the error if unsuccessful

  ### See also:

  - parse_message_header
prepare_content (mime)
  Set the mime type of following content data.

  ### Parameters

  - mime: Mimetype of following content
redirect (url)
  Redirects the client to a new URL and closes the connection.

  ### Parameters

  - url: Target URL
setfilehandler (callback)
  Set a handler function for incoming user file uploads.

  ### Parameters

  - callback: Handler function
source ()
  Get the RAW HTTP input source

  ### Return value:

  HTTP LTN12 source
splice (fp, size)
  Splice data from a filedescriptor to the client.

  ### Parameters

  - fp: File descriptor
  - size: Bytes to splice (optional)
status (code, message)
  Set the HTTP status code and status message.

  ### Parameters

  - code: Status code
  - message: Status message
urldecode (str, no_plus)
  Return the URL-decoded equivalent of a string.

  ### Parameters

  - str: URL-encoded string
  - no_plus: Don't decode + to " "

  ### Return value:

  URL-decoded string

  ### See also:

  - urlencode
urldecode_message_body (src, msg)
  Decode an urlencoded http message body with application/x-www-urlencoded Content-Type. Stores all extracted data associated with its parameter name in the params table within the given message object. Multiple parameter values are stored as tables, ordinary ones as strings.

  ### Parameters

  - src: Ltn12 source function
  - msg: HTTP message object

  ### Return values:

  1. Value indicating successful operation (not nil means "ok")
  2. String containing the error if unsuccessful

  ### See also:

  - parse_message_header
urldecode_params (url, tbl)
  Extract and split urlencoded data pairs, separated bei either "&" or ";" from given url or string. Returns a table with urldecoded values. Simple parameters are stored as string values associated with the parameter name within the table. Parameters with multiple values are stored as array containing the corresponding values.

  ### Parameters

  - url: The url or string which contains x-www-urlencoded form data
  - tbl: Use the given table for storing values (optional)

  ### Return value:

  Table containing the urldecoded parameters

  ### See also:

  - urlencode_params
urlencode (str)
  Return the URL-encoded equivalent of a string.

  ### Parameters

  - str: Source string

  ### Return value:

  URL-encoded string

  ### See also:

  - urldecode
urlencode_params (tbl)
  Encode each key-value-pair in given table to x-www-urlencoded format, separated by "&". Tables are encoded as parameters with multiple values by repeating the parameter name with each value.

  ### Parameters

  - tbl: Table with the values

  ### Return value:

  String containing encoded values

  ### See also:

  - urldecode_params
write (content, src_err)
  Send a chunk of content data to the client. This function is as a valid LTN12 sink. If the content chunk is nil this function will automatically invoke close.

  ### Parameters

  - content: Content chunk
  - src_err: Error object from source (optional)

  ### See also:

  - close
write_json (data)
  Send the given data as JSON encoded string.

  ### Parameters

  - data: Data to send